Subject: bug#7434: When an incorrect option is used before --help/--version, automake behaviour is inconsistent with that of other GNU programs.

From: Stefano Lattarini <[email-masked]>
Date: Thu, 18 Nov 2010 17:28:30 +0100

On Thursday 18 November 2010, Eric Blake wrote:
> On 11/18/2010 08:22 AM, Stefano Lattarini wrote:
> > Severity: wishlist
> > 
> > Currently, automake and aclocal scan their command line looking for
> > `--help' and `--version' even after an invalid option has been seen;
> > and in case one of those two options is seen, it takes precedence
> > even over error reporting about preceding invalid options.
> 
> GNU Coding Standards _only_ require that --help and --version be
> recognized as the first argument, with no other arguments.
> When possible, recognizing --help and --version after other arguments,
> or with other arguments afterwards, is nice, but there are no rules
> that require that consistency.
Not exactly.  The GNU Coding Standards read (my emphasis):

  ``The standard --version option should direct the program to print
    information about its name, version, origin and legal status, all
    on standard output, and then exit successfully. Other options and
    arguments should be ignored *once this is seen*, and the program
    should not perform its normal function.''

So it means that the behaviour of GNU m4 (and the other mentioned
programs) is compliant with the GCS, while the automake behaviour
is "overzealous" in this respect.

> [CUT]
> 
> > In conclusion: would you agree with a patch that converts automake and
> > aclocal to the same cmdline-scanning behaviour of the majority of other
> > GNU tools?  Such a patch would also have the advantage of *simplifying*
> > the current code for command line parsing in automake and aclocal.
> 
> Not necessarily on the grounds of making things match other tools, but
> definitely on the grounds of having simpler code that still complies
> with GCS.
Yes, that was truly my primary motivation.  The fact that the new automake
behaviour would match that of many other tools was just a "bonus".

Regards,
  Stefano